Bug 990065 - nfs+posix: "File name too long" with ltp test suite
nfs+posix: "File name too long" with ltp test suite
Status: CLOSED NOTABUG
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: glusterd (Show other bugs)
2.1
x86_64 Linux
medium Severity medium
: ---
: ---
Assigned To: santosh pradhan
Sudhir D
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-07-30 06:26 EDT by Saurabh
Modified: 2016-01-19 01:12 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-07-31 07:09:24 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Saurabh 2013-07-30 06:26:14 EDT
Description of problem:
executing the ltp  test suite throws warning in nfs.log and error messages in brick logs for "File name too long"
and test suite finishes with "POSIX: 14(Bad address)"

Version-Release number of selected component (if applicable):
[root@nfs2 ~]# rpm -qa | grep glusterfs
glusterfs-3.4.0.13rhs-1.el6rhs.x86_64
glusterfs-fuse-3.4.0.13rhs-1.el6rhs.x86_64
glusterfs-server-3.4.0.13rhs-1.el6rhs.x86_64


How reproducible:
always

Steps to Reproduce:
1. create a 6x2 volume, start it
2. mount the volume over nfs 
3. execute ltp test suite

Actual results:
from nfs.log
[2013-07-29 22:56:20.683211] W [client-rpc-fops.c:188:client3_3_symlink_cbk] 0-dist-rep-client-10: remote operation failed: File name too long. Path: (/run8944/p14/d2/l6 to xxxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxx)
[2013-07-29 22:56:20.683327] W [nfs3.c:2890:nfs3svc_symlink_cbk] 0-nfs: 123dd518: /run8944/p14/d2/l6 => -1 (File name too long)
[2013-07-29 23:00:18.914100] E [nfs3.c:1542:nfs3_access_resume] 0-nfs-nfsv3: No such file or directory: (10.70.37.11:961) dist-rep : 81682d44-ae61-4c62-a547-4ac1dc2c0886
[2013-07-29 23:00:18.914234] W [nfs3-helpers.c:3391:nfs3_log_common_res] 0-nfs-nfsv3: XID: c751d618, ACCESS: NFS: 2(No such file or directory), POSIX: 14(Bad address)
[2013-07-29 23:00:18.919282] E [nfs3.c:1542:nfs3_access_resume] 0-nfs-nfsv3: No such file or directory: (10.70.37.11:961) dist-rep : 81682d44-ae61-4c62-a547-4ac1dc2c0886
[2013-07-29 23:00:18.919400] W [nfs3-helpers.c:3391:nfs3_log_common_res] 0-nfs-nfsv3: XID: c851d618, ACCESS: NFS: 2(No such file or directory), POSIX: 14(Bad address)
[2013-07-29 23:00:18.923077] E [nfs3.c:1542:nfs3_access_resume] 0-nfs-nfsv3: No such file or directory: (10.70.37.11:961) dist-rep : 81682d44-ae61-4c62-a547-4ac1dc2c0886
[2013-07-29 23:00:18.923153] W [nfs3-helpers.c:3391:nfs3_log_common_res] 0-nfs-nfsv3: XID: c951d618, ACCESS: NFS: 2(No such file or directory), POSIX: 14(Bad address)
[2013-07-29 23:00:18.926291] E [nfs3.c:1542:nfs3_access_resume] 0-nfs-nfsv3: No such file or directory: (10.70.37.11:961) dist-rep : 81682d44-ae61-4c62-a547-4ac1dc2c0886
[2013-07-29 23:00:18.926407] W [nfs3-helpers.c:3391:nfs3_log_common_res] 0-nfs-nfsv3: XID: ca51d618, ACCESS: NFS: 2(No such file or directory), POSIX: 14(Bad address)
[2013-07-29 23:17:19.104051] I [afr-self-heal-entry.c:1866:afr_sh_entry_common_lookup_done] 0-dist-rep-replicate-0: /1779/88: Skipping entry self-heal because of gfid absence


from brick logs,
[2013-07-29 22:56:17.161037] I [server-rpc-fops.c:1159:server_symlink_cbk] 0-dist-rep-server: 13734593: SYMLINK /run8944/p6/l1 (4f869146-f82b-46c2-8344-2ef8cdfa9bed/l1) ==> (File name too long)
[2013-07-29 22:56:20.053421] E [posix.c:1279:posix_symlink] 0-dist-rep-posix: symlink of /rhs/bricks/d1r1/run8944/p6/l1 --> xxxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxxx/xxxxxxxx failed: File name too long
[2013-07-29 22:56:20.053570] I [server-rpc-fops.c:1159:server_symlink_cbk] 0-dist-rep-server: 13736530: SYMLINK /run8944/p6/l1 (6ae8fac5-319a-4657-bfa9-99e3553b5080/l1) ==> (File name too long)



Expected results:
Need to figure why this issue is happening!

Additional info:
A somewhat similar BZ 901723 was filed for RHS2.0, which is still to be taken care
Comment 2 santosh pradhan 2013-07-31 02:41:12 EDT
1. just do a sanity fsstress (LTP) test on native glusterfs mount point.

If it works, then NFS has issue.

2. From the log, it looks like the error comes from POSIX xlator.
Comment 4 santosh pradhan 2013-07-31 07:00:25 EDT

The error code ENAMETOOLONG is returned by symlink() syscall [POSIX compliant] from the posix xlator. The underlying File System (XFS) does not support filename length bigger than 255. 

Where GlusterFS does not have any control.

Did this fsstress test ever pass?

Otherwise it should not be considered as a bug from glusterFS perspective.

What do you say?
Comment 6 santosh pradhan 2013-07-31 07:16:26 EDT
fsstress tool is passing filenames longer than 255 bytes (chars) which gets rejected by XFS. Even the 255 limit holds with EXT2/3/4 filesystem. 

May be the fsstress/LTP tool is designed for reiserFS/ZFS which support 1024 or more.

Note You need to log in before you can comment on or make changes to this bug.